﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;
using AlipayClient.util;
using Newtonsoft.Json.Linq;
/*安全支付设置*/
namespace AlipayClient.ui
{
    public partial class AlipaySafepaySetting : PhoneApplicationPage, MessageDispatcher.IMessageCallBack
    {
        private string mSettingStatus;

        private DataHelper mDataHelper = null;
        private MessageDispatcher mMsgD = null;
        private MessageFilter mMessageFilter = null;
        private string mPayType;
        private string mPayQuota;
        private string mPayTypeMemo;
        private int mState = -1;//当前界面的操作状态

        public AlipaySafepaySetting()
        {
            InitializeComponent();

            mSettingStatus = this.mToggleSwitch.IsChecked.ToString();
            this.ApplicationTitle.Text = Constants.STR_ACCOUNT;
            mDataHelper = DataHelper.getInstance();
            mMsgD = new MessageDispatcher(LayoutRoot.Dispatcher, this);
            mMessageFilter = new MessageFilter(this);
            mState = 0;
            mDataHelper.sendQueryPaySettings(mMsgD, AlipayHandlerMessageIDs.QUERYPAYSETTINGS);
            BaseHelper.ShowLoading(MaskCanvas, LoadingMsg, true, Stringresource.GettingData);
            passwordBox1.KeyDown += new KeyEventHandler(passwordBox1_KeyDown);
        }
        void passwordBox1_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.Key == Key.Enter)
            {
                this.Focus();
            }
        }

        protected override void OnNavigatedTo(System.Windows.Navigation.NavigationEventArgs e)
        {
            base.OnNavigatedTo(e);
            if (App.isActive)
            {
                if (MaskCanvas.Visibility == Visibility.Visible)
                {
                    if (mState == 0)
                    {
                        mDataHelper.sendQueryPaySettings(mMsgD, AlipayHandlerMessageIDs.QUERYPAYSETTINGS);
                    }
                    else if (mState == 1)
                    {
                        sendModify();
                    }
                }
            }
        }
        public void HandlerMessage(Message msg)
        {
            switch (msg.what)
            {
                case AlipayHandlerMessageIDs.QUERYPAYSETTINGS:
                    parseSettingStatus(msg);
                    break;
                case AlipayHandlerMessageIDs.MODIFYPAYSETTINGS:
                    parseModifySettingStatus(msg);
                    break;
            }
            BaseHelper.ShowLoading(MaskCanvas, LoadingMsg, false, null);
        }
        /*解析json数据*/
        private void parseSettingStatus(Message msg)
        {
            bool tResultOK = false;
            tResultOK = mMessageFilter.process(msg, this);
            if (tResultOK)
            {
                JObject respJson = JObject.Parse((string)msg.obj); ;
                DataHelper.setRSADate((string)respJson[JsonParseDefine.RSAPK], (string)respJson[JsonParseDefine.RSATS]);
                mPayType = (string)respJson[JsonParseDefine.PAYTYPE];
                mPayQuota = (string)respJson[JsonParseDefine.PAYQUOTA];
                mPayTypeMemo = (string)respJson[JsonParseDefine.PAYTYPEMEMO];
                
                updateUI();              
            }
           
        }

        /*解析json数据*/
        private void parseModifySettingStatus(Message msg)
        {
            bool tResultOK = false;
            tResultOK = mMessageFilter.process(msg, this);
            if (tResultOK)
            {                             
                JObject respJson = JObject.Parse((string)msg.obj); ;
                MessageBoxResult mResult = MessageBox.Show((string)respJson[JsonParseDefine.MEMO],Stringresource.MessageBoxTitle,MessageBoxButton.OK);
                if (mResult == MessageBoxResult.OK)
                {
                    NavigationService.GoBack();
                }
            }
        }

        private void updateUI()
        {
            if (mPayType.Equals("00"))
            {
                mToggleSwitch.IsChecked = true;
                textBlock2.Text = Stringresource.SafeOn;
            }
            else
            {
                mToggleSwitch.IsChecked = false;
                textBlock2.Text = Stringresource.SafeOff;
            }
            mSettingStatus = this.mToggleSwitch.IsChecked.ToString();
            mSafeInfo.Text = mPayTypeMemo;
            mCanUseMoney.Text = mPayQuota;
            this.mPasswordGrid.Visibility = Visibility.Collapsed;
            this.ApplicationBar.IsVisible = false;
        }

        private void toggleSwitch1_Checked(object sender, RoutedEventArgs e)
        {
            textBlock2.Text = Stringresource.SafeOn;
            if (!mSettingStatus.Equals(this.mToggleSwitch.IsChecked.ToString()))
            {
                this.mPasswordGrid.Visibility = Visibility.Visible;
                this.ApplicationBar.IsVisible = true;
            }
            else
            {
                this.mPasswordGrid.Visibility = Visibility.Collapsed;
                this.ApplicationBar.IsVisible = false;
            }
        }

        private void toggleSwitch1_Unchecked(object sender, RoutedEventArgs e)
        {
            textBlock2.Text = Stringresource.SafeOff;
            if(!mSettingStatus.Equals(this.mToggleSwitch.IsChecked.ToString()))
            {
                this.mPasswordGrid.Visibility = Visibility.Visible;
                this.ApplicationBar.IsVisible = true;
            }
            else
            {
                this.mPasswordGrid.Visibility = Visibility.Collapsed;
                this.ApplicationBar.IsVisible = false;
            }
        }

        //private void ShowLoading(bool isShow, String msg)
        //{
        //    if (isShow)
        //    {
        //        MaskCanvas.Visibility = Visibility.Visible;
        //        LoadingMsg.Text = msg;
        //    }
        //    else
        //    {
        //        MaskCanvas.Visibility = Visibility.Collapsed;
        //    }

        //}

        //private void mConfim_Click(object sender, RoutedEventArgs e)
        //{
        //    string tType = "";
        //    string tPass = passwordBox1.Password;
        //    int tResult = AlipayInputErrorCheck.checkPayingPassword(tPass);
        //    if (tResult != AlipayInputErrorCheck.NO_ERROR)
        //    {
        //        // check error.
        //        String warningMsg;
        //        if (tResult == AlipayInputErrorCheck.ERROR_INVALID_FORMAT)
        //        {
        //            warningMsg = Stringresource.WarningInvalidLoginPassword;
        //        }
        //        else if (tResult == AlipayInputErrorCheck.ERROR_NULL_INPUT)
        //        {
        //            warningMsg = Stringresource.NoEmptyPassword;
        //        }
        //        else
        //        {
        //            warningMsg = "UNKNOWN_ERROR TYPE = " + tResult;
        //            // Log.i(LOG_TAG, warningMsg);
        //        }
        //        //MessageBox.Show(warningMsg);
        //        BaseHelper.AlipayMessageBox(warningMsg);
        //        return;
        //    }
        //    if (mToggleSwitch.IsChecked.ToString().ToUpper().Equals("TRUE"))
        //    {              
        //        tType = "00";
        //    }
        //    else
        //    {
        //        tType = "01";
        //    }
        //    mDataHelper.sendModifyPaySettings(mMsgD, AlipayHandlerMessageIDs.MODIFYPAYSETTINGS, tPass, tType);
        //    BaseHelper.ShowLoading(MaskCanvas, LoadingMsg, true, Stringresource.GettingData);
        //}

        private void sendModify()
        {
            string tType = "";
            string tPass = passwordBox1.Password;
            int tResult = AlipayInputErrorCheck.checkPayingPassword(tPass);
            if (tResult != AlipayInputErrorCheck.NO_ERROR)
            {
                // check error.
                String warningMsg;
                if (tResult == AlipayInputErrorCheck.ERROR_INVALID_FORMAT)
                {
                    warningMsg = Stringresource.WarningInvalidLoginPassword;
                }
                else if (tResult == AlipayInputErrorCheck.ERROR_NULL_INPUT)
                {
                    warningMsg = Stringresource.NoEmptyPassword;
                }
                else
                {
                    warningMsg = "UNKNOWN_ERROR TYPE = " + tResult;
                    // Log.i(LOG_TAG, warningMsg);
                }
                //MessageBox.Show(warningMsg);
                BaseHelper.AlipayMessageBox(warningMsg);
                return;
            }
            if (mToggleSwitch.IsChecked.ToString().ToUpper().Equals("TRUE"))
            {
                tType = "00";
            }
            else
            {
                tType = "01";
            }
            mState = 1;
            mDataHelper.sendModifyPaySettings(mMsgD, AlipayHandlerMessageIDs.MODIFYPAYSETTINGS, tPass, tType);
            BaseHelper.ShowLoading(MaskCanvas, LoadingMsg, true, Stringresource.GettingData);
        }

        private void ApplicationBarIconButton_Click(object sender, EventArgs e)
        {
            sendModify();
        }

    }
}